"use strict";
var React = require("react");
var EventEmitter = require("events");
var enzyme_1 = require("enzyme");
var Swatch_1 = require("../Swatch");
var TestUtils = require("react-addons-test-utils");
var mockedSetBackround = function (val) { };
describe("Swatch", function () {
    it("should exist", function () {
        var SpiedChannel = new EventEmitter();
        var swatch = enzyme_1.shallow(React.createElement(Swatch_1.default, {value: "bar", name: "foo", setBackground: mockedSetBackround}));
        expect(swatch).toBeDefined();
    });
    it("should render the name of the swatch", function () {
        var markup = enzyme_1.shallow(React.createElement(Swatch_1.default, {value: "bar", name: "foo", setBackground: mockedSetBackround})).html();
        expect(markup.match(/foo/gmi).length).toBe(1);
    });
    it("should render the value of the swatch and set it to be the background", function () {
        var markup = enzyme_1.shallow(React.createElement(Swatch_1.default, {value: "bar", name: "foo", setBackground: mockedSetBackround})).html();
        expect(markup.match(/background:bar/gmi).length).toBe(1);
        expect(markup.match(/bar/gmi).length).toBe(2);
    });
    it("should emit message on click", function () {
        var spy = jest.fn();
        var swatch = enzyme_1.mount(React.createElement(Swatch_1.default, {value: "#e6e6e6", name: "Gray", setBackground: spy}));
        swatch.simulate("click");
        expect(spy).toBeCalledWith("#e6e6e6");
    });
});
//# sourceMappingURL=Swatch.js.map